<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Danh sách đơn hàng</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js "></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js "></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js "></script>

    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js "></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js "></script>
</head>

<body class="hold-transition sidebar-mini layout-fixed" onload="onPageLoading()">
    <div class=" wrapper">
        <nav class="main-header navbar navbar-expand navbar-white navbar-light ">
            <!-- Left navbar links -->
            <ul class="navbar-nav ">
                <li class="nav-item ">
                    <a class="nav-link " data-widget="pushmenu " href="# " role="button "><i class="fas fa-bars "></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block ">
                    <a href="# " class="nav-link ">Danh sách đơn hàng</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto ">

                <!-- Notifications Dropdown Menu -->
                <li class="nav-item ">
                    <a class="nav-link " data-widget="fullscreen " href="# " role="button ">
                        <i class="fas fa-expand-arrows-alt "></i>
                    </a>
                </li>
            </ul>
        </nav>
        <aside class="main-sidebar sidebar-dark-primary elevation-4 ">
            <!-- Brand Logo -->
            <a href="# " class="brand-link ">
                <span class="brand-text font-weight-light ">Task 45.</span>
            </a>
            <!-- Sidebar -->
            <div class="sidebar ">

                <!-- Sidebar Menu -->
                <nav class="mt-2 ">
                    <ul class="nav nav-pills nav-sidebar flex-column " data-widget="treeview " role="menu " data-accordion="false ">
                        <!-- Add icons to the links using the .nav-icon class
                       with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open ">
                            <a href="# " class="nav-link active ">
                                <i class="nav-icon fas fa-tachometer-alt "></i>
                                <p>
                                    Dashboard
                                    <i class="right fas fa-angle-left "></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview ">
                                <li class="nav-item ">
                                    <a href="./index1.html " class="nav-link ">
                                        <i class="far fa-circle nav-icon "></i>
                                        <p>Dashboard v1</p>
                                    </a>
                                </li>
                                <li class="nav-item ">
                                    <a href="./index2.html " class="nav-link ">
                                        <i class="far fa-circle nav-icon "></i>
                                        <p>Dashboard v2</p>
                                    </a>
                                </li>
                                <li class="nav-item ">
                                    <a href="./index3.html " class="nav-link active">
                                        <i class="far fa-circle nav-icon "></i>
                                        <p>Dashboard v3</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="nav-item ">
                            <a href="pages/widgets.html " class="nav-link ">
                                <i class="nav-icon fas fa-th "></i>
                                <p>
                                    Widgets
                                    <span class="right badge badge-danger ">New</span>
                                </p>
                            </a>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper ">
            <!-- Content Header (Page header) -->
            <div class="content-header ">
                <div class="container ">
                    <div class="text-center ">
                        <h2>Danh sách đơn hàng</h2>
                    </div>
                </div>
            </div>
            <section class="content ">
                <div class="container jumbotron">
                    <div class="row form-group">
                        <div class="row col-md-5">
                            <div class="col-md-6 text-center">
                                <label class="form-group mx-2">Trạng thái order</label>
                            </div>
                            <div class="col-md-6">
                                <select class="form-control" id="sel-status">
                                    <option value="all">All</option>
                                    <option value="open">Open</option>
                                    <option value="confirmed">Confirmed</option>
                                    <option value="cancel">Cancel</option>
                                </select>
                            </div>
                        </div>
                        <div class="row col-md-5">
                            <div class="col-md-6 text-center">
                                <label class="form-group mx-2">Loại Pizza</label>
                            </div>
                            <div class="col-md-6">
                                <select class="form-control" id="sel-pizza">
                                    <option value="all">All</option>
                                    <option value="hawaii">Hawaii</option>
                                    <option value="bacon">Bacon</option>
                                    <option value="seafood">Seafood</option>
                                </select>
                            </div>
                        </div>
                        <div class="row col-md-2">
                            <div class="col-md-12 text-right">
                                <button id="btn-filter" class="btn btn-success">Lọc</button>
                            </div>
                        </div>
                    </div>
                </div>
                <table class="table table-bordered table-striped table-hover" id="table-order">
                    <thead>
                        <tr>
                            <td>Order ID</td>
                            <td>Kích cỡ combo</td>
                            <td>Loại Pizza</td>
                            <td>Nước uống</td>
                            <td>Thành tiền</td>
                            <td>Họ và tên</td>
                            <td>Số điện thoại</td>
                            <td>Trạng thái</td>
                            <td>Action</td>
                        </tr>
                    </thead>
                </table>
                <div id="order-modal" class="modal fade">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title">Order Detail</h5>
                            </div>
                            <div class="modal-body">
                                <div class="form-group">
                                    <label>Order ID (mã đơn hàng)</label>
                                    <input class="form-control" id="inp-id">
                                </div>
                                <div class=" form-group">
                                    <label>Cỡ Combo</label>
                                    <input class="form-control" id="inp-kichco">
                                </div>
                                <div class="form-group">
                                    <label>Đường kính Pizza</label>
                                    <input class="form-control" id="inp-duongkinh">
                                </div>
                                <div class="form-group">
                                    <label>Sườn nướng (miếng)</label>
                                    <input class="form-control" id="inp-suon">
                                </div>
                                <div class="form-group">
                                    <label>Đồ uống</label>
                                    <input class="form-control" id="inp-douong">
                                </div>
                                <div class=" form-group">
                                    <label>Số lượng nước uống</label>
                                    <input class="form-control" id="inp-soluongnuoc">
                                </div>
                                <div class=" form-group">
                                    <label>Voucher ID (mã giảm giá)</label>
                                    <input class="form-control" id="inp-voucher">
                                </div>
                                <div class="form-group">
                                    <label>Loại Pizza</label>
                                    <input class="form-control" id="inp-pizza">
                                </div>
                                <div class="form-group">
                                    <label>Salad</label>
                                    <input class="form-control" id="inp-salad">
                                </div>
                                <div class="form-group">
                                    <label>Thành tiền</label>
                                    <input class="form-control" id="inp-thanhtien">
                                </div>
                                <div class="form-group">
                                    <label>Giảm giá</label>
                                    <input class="form-control" id="inp-giamgia">
                                </div>
                                <div class=" form-group">
                                    <label>Họ và tên</label>
                                    <input class="form-control" id="inp-hovaten">
                                </div>
                                <div class=" form-group">
                                    <label>Email </label>
                                    <input class="form-control" id="inp-email">
                                </div>
                                <div class="form-group">
                                    <label>Số điện thoại</label>
                                    <input class="form-control" id="inp-sodienthoai">
                                </div>
                                <div class=" form-group">
                                    <label>Địa chỉ</label>
                                    <input class="form-control" id="inp-diachi">
                                </div>
                                <div class=" form-group">
                                    <label>Lời nhắn</label>
                                    <input class="form-control" id="inp-loinhan">
                                </div>
                                <div class=" form-group">
                                    <label>Trạng thái đơn hàng</label>
                                    <input class="form-control" id="inp-trangthai">
                                </div>
                                <div class=" form-group">
                                    <label>Ngày tạo</label>
                                    <input class="form-control" id="inp-ngaytao">
                                </div>
                                <div class="form-group">
                                    <label>Ngày cập nhật</label>
                                    <input class="form-control" id="inp-ngaycapnhat">
                                </div>
                            </div>
                            <div class="modal-footer">
                                <button id="btn-confirm" class="btn btn-success">Confirm</button>
                                <button id="btn-cancel" class="btn btn-secondary">Cancel</button>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
        </div>
        <!-- /.content-wrapper -->
        <footer class="main-footer ">
            <strong>Copyright &copy; 2022 Danh sách đơn hàng Devcamp</strong> All rights reserved.
            <div class="float-right d-none d-sm-inline-block ">
                <b>Version</b> 1.0.0
            </div>
        </footer>
    </div>

    <script>
        $(document).ready(function() {
            // Region 1 - khai bao bien
            var gDataOrder = [];
            const gOrder = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"]
            const gID_col = 0;
            const gkichCo_col = 1;
            const gloaiPizza_col = 2;
            const gidLoaiNuocUong_col = 3;
            const gthanhTien_col = 4;
            const ghoTen_col = 5;
            const gsoDienThoai_col = 6;
            const gtrangThai_col = 7;
            const gaction_col = 8;

            var gId;
            var gOrderId;
            $("#table-order").DataTable({
                columns: [{
                    data: gOrder[gID_col]
                }, {
                    data: gOrder[gkichCo_col]
                }, {
                    data: gOrder[gloaiPizza_col]
                }, {
                    data: gOrder[gidLoaiNuocUong_col]
                }, {
                    data: gOrder[gthanhTien_col]
                }, {
                    data: gOrder[ghoTen_col]
                }, {
                    data: gOrder[gsoDienThoai_col]
                }, {
                    data: gOrder[gtrangThai_col]
                }, {
                    data: gOrder[gaction_col]
                }, ],
                columnDefs: [{
                    targets: gaction_col,
                    defaultContent: "<button class='btn-detail btn btn-primary'>Chi tiết</button>"
                }]
            })

            // Region 2 - vung gan / thuc thi ham
            onPageLoading();
            $("#table-order").on("click", ".btn-detail", function() {
                onBtnDetailClick(this);
                $("#order-modal").modal("show");
                LoadDataToModal();


            })
            $("#btn-filter").on("click", function() {
                onBtnFilterClick();
            })
            $(document).on("click", "#btn-confirm", function() {
                onBtnShowDetailClick();
                ConfirmOrderClick(gId);
            })
            $(document).on("click", "#btn-cancel", function() {
                    onBtnShowDetailClick()
                    CancelOrderClick(gId);
                })
                // Region 3 - Khai bao ham xu ly su kien
            function onPageLoading() {
                "use strict";
                $.ajax({
                    url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
                    type: "GET",
                    dataType: "json",
                    success: function(res) {
                        gDataOrder = res;
                        console.log(gDataOrder);
                        LoadDataToTable(gDataOrder);
                    },
                    error: function(res) {
                        console.assert(res.responseText)
                    }
                })
            }
            // Region 4 - Khai bao ham dung chung
            function onBtnDetailClick(paramThis) {
                "use strict";
                var vRow = $(paramThis).closest("tr");
                var vTable = $("#table-order").DataTable();
                var vData = vTable.row(vRow).data();
                gId = vData.id;
                gOrderId = vData.orderId;
                console.log("ID là " + gId)
                console.log("OrderID là " + gOrderId)
            }

            function LoadDataToTable(paramOrder) {
                "use strict";
                var vUserTable = $("#table-order").DataTable();
                vUserTable.clear();
                vUserTable.rows.add(paramOrder);
                vUserTable.draw();
            }

            function onBtnFilterClick() {
                "use strict";
                var vStatus = $("#sel-status").val();
                var vPizza = $("#sel-pizza").val();
                console.log(vPizza);
                var vDataFilter = gDataOrder.filter(function(paramOrder, index) {
                    return (vStatus === "all" || vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase()) && (vPizza === "all" || vPizza.toUpperCase() === paramOrder.loaiPizza.toUpperCase())
                });

                LoadDataToTable(vDataFilter);
            }

            function LoadDataToModal() {
                "use strict";
                $.ajax({
                    url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + gOrderId,
                    type: "GET",
                    dataType: "json",
                    success: function(res) {
                        console.log(res);
                        showDataModal(res);
                    },
                    error: function(res) {
                        console.assert(res.responseText)
                    }
                })
            }

            function showDataModal(paramModal) {
                "use strict";
                $("#inp-id").val(paramModal.id)
                $("#inp-diachi").val(paramModal.diaChi)
                $("#inp-duongkinh").val(paramModal.duongKinh)
                $("#inp-email").val(paramModal.email)
                $("#inp-giamgia").val(paramModal.giamGia)
                $("#inp-hovaten").val(paramModal.hoTen)
                $("#inp-douong").val(paramModal.idLoaiNuocUong)
                $("#inp-voucher").val(paramModal.idVourcher)
                $("#inp-kichco").val(paramModal.kichCo)
                $("#inp-pizza").val(paramModal.loaiPizza)
                $("#inp-loinhan").val(paramModal.loiNhan)
                $("#inp-ngaytao").val(paramModal.ngayTao)
                $("#inp-ngaycapnhat").val(paramModal.ngayCapNhat)
                $("#inp-soluongnuoc").val(paramModal.soLuongNuoc)
                $("#inp-orderid").val(paramModal.orderId)
                $("#inp-salad").val(paramModal.salad)
                $("#inp-sodienthoai").val(paramModal.soDienThoai)
                $("#inp-suon").val(paramModal.suon)
                $("#inp-thanhtien").val(paramModal.thanhTien)
                $("#inp-trangthai").val(paramModal.trangThai)
            }

            function onBtnShowDetailClick() {
                "use strict";
                var vObjectUpdate = {
                    kichCo: "",
                    duongKinh: "",
                    suon: "",
                    salad: "",
                    loaiPizza: "",
                    idVourcher: "",
                    idLoaiNuocUong: "",
                    soLuongNuoc: "",
                    hoTen: "",
                    thanhTien: "",
                    email: "",
                    soDienThoai: "",
                    diaChi: "",
                    loiNhan: ""
                }
                console.log("ID là" + gId);
                getInfo(vObjectUpdate);
                var vCheck = checkInfo(vObjectUpdate);
                if (vCheck) {
                    console.log(vObjectUpdate)
                }
            }

            function getInfo(paramObj) {
                "use strict";
                paramObj.id = $.trim($("#inp-id").val())
                paramObj.kichCo = $.trim($("#inp-kichco").val())
                paramObj.duongKinh = $.trim($("#inp-duongkinh").val())
                paramObj.suon = $.trim($("#inp-suon").val())
                paramObj.douong = $.trim($("#inp-douong").val())
                paramObj.salad = $.trim($("#inp-salad").val())
                paramObj.loaiPizza = $.trim($("#inp-pizza").val())
                paramObj.idVourcher = $.trim($("#inp-voucher").val())
                paramObj.idLoaiNuocUong = $.trim($("#inp-douong").val())
                paramObj.soLuongNuoc = $.trim($("#inp-soluongnuoc").val())
                paramObj.hoTen = $.trim($("#inp-hovaten").val())
                paramObj.thanhTien = $.trim($("#inp-thanhtien").val())
                paramObj.giamGia = $.trim($("#inp-giamgia").val())
                paramObj.email = $.trim($("#inp-email").val())
                paramObj.soDienThoai = $.trim($("#inp-sodienthoai").val())
                paramObj.diaChi = $.trim($("#inp-diachi").val())
                paramObj.loiNhan = $.trim($("#inp-loinhan").val())
            }

            function checkInfo(paramObj) {
                "use strict;"
                if (paramObj.diaChi == "") {
                    alert("Vui lòng nhập địa chỉ giao hàng");
                    return false;
                }
                if (paramObj.id == "") {
                    alert("Vui lòng nhập ID");
                    return false;
                }
                if (paramObj.kichCo == "") {
                    alert("Vui lòng kích cỡ bánh");
                    return false;
                }
                if (paramObj.duongKinh == "") {
                    alert("Vui lòng Size bánh");
                    return false;
                }
                if (paramObj.email == "") {
                    alert("Vui lòng Email");
                    return false;
                }
                if (paramObj.giamGia == "") {
                    alert("Vui lòng số tiền giảm giá");
                    return false;
                }
                if (paramObj.hoTen == "") {
                    alert("Vui lòng họ và tên");
                    return false;
                }
                if (paramObj.idLoaiNuocUong == "") {
                    alert("Vui lòng Loại nước uống");
                    return false;
                }
                if (paramObj.idVourcher == "") {
                    alert("Vui lòng mã giảm giá");
                    return false;
                }
                if (paramObj.loiNhan == "") {
                    alert("Vui lòng lời nhắn");
                    return false;
                }
                if (paramObj.ngayCapNhat == "") {
                    alert("Vui lòng nhập ngày cập nhật");
                    return false;
                }
                if (paramObj.ngayTao == "") {
                    alert("Vui lòng nhập ngày tạo");
                    return false;
                }
                if (paramObj.salad == "") {
                    alert("Vui lòng nhập Salad");
                    return false;
                }
                if (paramObj.soDienThoai == "") {
                    alert("Vui lòng nhập số điện thoại");
                    return false;
                }
                if (paramObj.suon == "") {
                    alert("Vui lòng nhập sườn");
                    return false;
                }
                if (paramObj.thanhTien == "") {
                    alert("Vui lòng nhập Giá tiền");
                    return false;
                }
                return true;
            }

            function ConfirmOrderClick(paramConfirm) {
                "use strict";
                var vObj = {
                    trangThai: "confirm", // hien thi trang thai, luc dau dang la cancel => chuyen qua confirm
                }
                var vJSonString = JSON.stringify(vObj);
                $.ajax({
                    url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + gId,
                    type: "PUT",
                    dataType: "json",
                    contentType: "application/json;charset=utf-8",
                    data: vJSonString,
                    success: function(res) {
                        alert("User ID: " + res.id + "\n Cập nhật thành công!");
                        window.location.href = "Task 41.55.html"
                    },
                    error: function(res) {
                        console.assert(res.responseText)
                    }
                })
            }

            function CancelOrderClick(paramCancel) {
                "use strict";
                var vObj = {
                    trangThai: "cancel", // hien thi trang thai, luc dau dang la cancel => chuyen qua confirm
                }
                var vJSonString = JSON.stringify(vObj);
                $.ajax({
                    url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + gId,
                    type: "PUT",
                    dataType: "json",
                    contentType: "application/json;charset=utf-8",
                    data: vJSonString,
                    success: function(res) {
                        alert("User ID: " + res.id + "\n Hủy đơn hàng thành công!");
                        window.location.href = "Task 41.55.html"
                    },
                    error: function(res) {
                        console.assert(res.responseText)
                    }
                })
            }
        })
    </script>
</body>


</html>